\section{Results}

\noindent Within the~scope of the~thesis the~architecture of~efficient \mbox{\as{fpga}-based} forwarding engine for \al{wrs} was proposed. The~design fulfils the~project requirements presented at the~beginning of the~thesis. The~differences between the~current\footnote{The overall logic resources for the~current implementation are based on the~evaluation of \al{wrs} firmware for the~Xilinx Zynq UltraScale+ (US+) MPSoC XCZU11EG-1FFVC1156E device~\cite{ultrascale-eval}.} and the~developed implementations are depicted in table \ref{t:comparison}. The~key contributions comprise:
\begin{itemize}
	\item modular and scalable architecture,
	\item introducing pipelined processing,
	\item parallel access to separate hash sub-tables storing a~\as{mac} table keys that allows for the~effective use of embedded memory resources,
	\item adjusting the~design to the~Xilinx Zynq UltraScale+ MPSoC architecture.
\end{itemize}
It should be noticed that specific project requirements, especially the~necessity to be able to perform lookups and make forwarding decisions for a~maximum possible number of requests per second, restrict possibilities of further architecture optimization. The implementation results -- used resources of the device view and the power usage summary -- are presented in figures \ref{fig:floorplan} and \ref{fig:power}.

Moreover, the~thesis contains a~comprehensive analysis of possible forwarding engine architectures for miscellaneous project requirements. To the~best of the~author's knowledge, there is no other work that summarizes and compares all known methods of the~Ethernet \as{l2} switch Filtering Database implementation. The~presented review of the~literature may also be valuable for other exact matching lookup engines implementations.

\begin{table}[H]
	\centering
	\small
	\caption{The comparison of the~current and the~developed WRS forwarding engines.}
	\label{t:comparison}
	\begin{tabular}{||>{\arraybackslash}m{0.3\textwidth}|
			>{\centering\arraybackslash}m{0.3\textwidth}|
			>{\centering\arraybackslash}m{0.3\textwidth}||}
		\hline
		\centering{\textbf{Parameter}} & \textbf{Current implementation} & \textbf{Developed implementation} \\ \hline\hline
		FPGA device & XCZU11EG-1FFVC1156E & XCZU17EG-1FFVC1760E \\ \hline
		Overall logic resources\tablefootnote{Expression X / Y  means that there are used X resources out of Y available for the specific FPGA device.} & 6,400 / 597,120 regs \newline
		5,400 / 298,560 LUTs \newline
		23 / 600 BRAM blocks \newline
		0.8 / 21.1 BRAM (Mb) \newline
		0 / 80 URAM blocks \newline
		0 / 22.5 URAM (Mb)
		& 2,749 / 846,806 regs \newline
		1,568 / 423,403 LUTs \newline
		78 / 796 BRAM blocks \newline
		2.7 / 28.0 BRAM (Mb) \newline
		11 / 102 URAM blocks \newline
		3.1 / 28.7 URAM (Mb)\\ \hline
		\as{htab} capacity & 2048 entries \newline (512 buckets and 4 slots per bucket) & 20480 entries \newline (5 sub-tables with 4096 buckets and 1 slot per bucket)\\ \hline
		\as{htab} hash function & CRC-16 polynomials \newline \verb|0x1021|, \verb|0x8005|, \verb|0x0589| & CRC-16 polynomials \newline \verb|0x1021|, \verb|0x8005|, \verb|0xC867| \newline CRC-32 polynomials \newline \verb|0x04C11DB7|, \verb|0x1EDC6F41| \\ \hline
		\as{mtab} capacity & -- & 10240 entries \\ \hline
		\as{vtab} capacity & 4096 entries & 4096 entries \\ \hline
		Lookup latency & 15 clock cycles for Full Lookup \newline
		23 clock cycles for Fast Lookup & 14 clock cycles \\ \hline
		Frequency & 62.5 MHz & 358 MHz\\ \hline
		Pipeline architecture & pipeline processing provided by Fast Lookup only for critical traffic  & \cmark \\ \hline
		Scalability & \xmark & \cmark \\ \hline
	\end{tabular}
\end{table}

\begin{figure}[H]
	\centering
	\includegraphics[scale=0.65]{pic/floorplan.png}
	\caption{Post-implementation FPGA device view.}
	\label{fig:floorplan}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[scale=0.6]{pic/power.png}
	\caption{Post-implementation power summary.}
	\label{fig:power}
\end{figure}

\section{Further Work}

\noindent Since the~\al{wrs} firmware is not fully adjusted to the~4th version of its hardware platform yet, further work should concern the~integration of~the~developed forwarding engine with the~rest of target firmware and conducting hardware tests. Although a~single forwarding engine module succeeds in implementation with clock frequency configured as 358~MHz, the~overall \as{wrs} firmware may require lower frequency and, thus, forwarding engine modules multiplication, as explained in section \ref{multiple-forwarding-engines}. Other architecture alternatives are presented in section \ref{forwarding-engine-architecture-alternatives}.

Furthermore, the~project may be continued with the~analysis of multiple matching lookup engines architectures, suitable for \as{ipprot} address lookup or intrusion detection systems. On the~contrary to the~exact matching lookup, state-of-the-art research in the~scope of multiple matching is concentrated on tree-based solutions.

